<?php

class Logger {
	
	private static function write($type, $message) {
		$log_file = fopen($_SERVER['DOCUMENT_ROOT'] . "/payment/Payture/" . "payture_module.log", 'a');
		$date = date('Y-m-d H:i:s');
		$data = $date . ' - ' . $type . ' - ' . $message . "\n";

		fwrite($log_file, $data);
		fclose($log_file);
		return;
	}

	public static function info($message) {	
		self::write('[INFO]', $message);
		return;
	}

	public static function error($message) {
		self::write('[ERROR]', $message);
		return;
	}
}

function request( $host, $paymethod, $params )
{
	$ch = curl_init();
	$requestLink = generateLink($host, $paymethod, $params);
	
	curl_setopt($ch, CURLOPT_URL, $requestLink);
	curl_setopt($ch, CURLOPT_POST, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_TIMEOUT, 30);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);	
	
	Logger::info('Sending GET request: ' . $requestLink);
	$result = curl_exec( $ch );

	if (FALSE === $result)
	{
		Logger::error('Failed to send request : ' . $requestLink);
        throw new Exception(curl_error($ch), curl_errno($ch));
		die(curl_error($ch) . " - " . curl_errno($ch));
	}	

	curl_close( $ch );

	Logger::info('Server responded: ' . $result);
	Logger::info('Parsing XML-response...');


	$response_xml = simplexml_load_string($result);
	if ($response_xml === false) {
		Logger::info('Failed to parse XML-response');
		die();
	}

	$node = xml2array($response_xml);
	
	Logger::info('Parsing XML-response succeded: ' . $node["@attributes"]);
	return $node["@attributes"];
}

function generateLink($host, $method, $params) {
	$link = $host . "/" . $method . "?" . $params; 
	return $link;
}

function xml2array( $xmlObject, $out = array() ) {
    foreach ( (array) $xmlObject as $index => $node )
        $out[$index] = ( is_object ( $node ) ) ? xml2array ( $node ) : $node;
    return $out;
}


?>

